package xyz.pixelatedw.betterbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import net.minecraft.level.Level;
import net.minecraft.tile.SugarCane;
import net.minecraft.tile.Tile;
import net.minecraft.tile.material.Material;
import xyz.pixelatedw.betterbeta.ModConfig;

@Mixin(SugarCane.class)
public class SugarCaneMixin {
	@Inject(method = "canPlaceAt", at = @At("HEAD"), cancellable = true)
	public void canPlaceAt(Level arg, int x, int y, int z, CallbackInfoReturnable<Boolean> info) {
		if(ModConfig.SUGAR_CANE_ON_SAND.get()) {
			int tileBelow = arg.getTileId(x, y - 1, z);
			if (tileBelow == Tile.SAND.id) {
				boolean flag = false;
				// Check if there is a water block around the sand block
				flag |= arg.getMaterial(x - 1, y - 1, z) == Material.WATER;
				flag |= arg.getMaterial(x + 1, y - 1, z) == Material.WATER;
				flag |= arg.getMaterial(x, y - 1, z - 1) == Material.WATER;
				flag |= arg.getMaterial(x, y - 1, z + 1) == Material.WATER;
				
				if (flag) {
					info.setReturnValue(true);
				}
			}		
		}
	}
}
